diff --git a/src/bin/pg_upgrade/option.c b/src/bin/pg_upgrade/option.c
index aca1ee8b48..ee245c7e02 100644
--- a/src/bin/pg_upgrade/option.c
+++ b/src/bin/pg_upgrade/option.c
@@ -43,6 +43,8 @@ parseCommandLine(int argc, char *argv[])
 		{"new-datadir", required_argument, NULL, 'D'},
 		{"old-bindir", required_argument, NULL, 'b'},
 		{"new-bindir", required_argument, NULL, 'B'},
+		{"old-libexecdir", required_argument, NULL, 'l'},
+		{"new-libexecdir", required_argument, NULL, 'L'},
 		{"old-options", required_argument, NULL, 'o'},
 		{"new-options", required_argument, NULL, 'O'},
 		{"old-port", required_argument, NULL, 'p'},
@@ -101,7 +103,7 @@ parseCommandLine(int argc, char *argv[])
 	if (os_user_effective_id == 0)
 		pg_fatal("%s: cannot be run as root\n", os_info.progname);
 
-	while ((option = getopt_long(argc, argv, "d:D:b:B:cj:ko:O:p:P:rs:U:v",
+	while ((option = getopt_long(argc, argv, "d:D:b:B:cj:kl:L:o:O:p:P:rs:U:v",
 								 long_options, &optindex)) != -1)
 	{
 		switch (option)
@@ -134,6 +136,14 @@ parseCommandLine(int argc, char *argv[])
 				user_opts.transfer_mode = TRANSFER_MODE_LINK;
 				break;
 
+			case 'l':
+				old_cluster.libexecdir = pg_strdup(optarg);
+				break;
+
+			case 'L':
+				new_cluster.libexecdir = pg_strdup(optarg);
+				break;
+
 			case 'o':
 				/* append option? */
 				if (!old_cluster.pgopts)
@@ -251,6 +261,10 @@ parseCommandLine(int argc, char *argv[])
 							 "-b", _("old cluster binaries reside"), false);
 	check_required_directory(&new_cluster.bindir, "PGBINNEW", false,
 							 "-B", _("new cluster binaries reside"), true);
+	check_required_directory(&old_cluster.libexecdir, "PGLIBEXECOLD", false,
+							 "-l", _("old cluster commands reside"), false);
+	check_required_directory(&new_cluster.libexecdir, "PGLIBEXECNEW", false,
+							 "-L", _("new cluster commands reside"), true);
 	check_required_directory(&old_cluster.pgdata, "PGDATAOLD", false,
 							 "-d", _("old cluster data resides"), false);
 	check_required_directory(&new_cluster.pgdata, "PGDATANEW", false,
@@ -289,25 +303,27 @@ usage(void)
 	printf(_("Usage:\n"));
 	printf(_("  pg_upgrade [OPTION]...\n\n"));
 	printf(_("Options:\n"));
-	printf(_("  -b, --old-bindir=BINDIR       old cluster executable directory\n"));
-	printf(_("  -B, --new-bindir=BINDIR       new cluster executable directory (default\n"
-			 "                                same directory as pg_upgrade)\n"));
-	printf(_("  -c, --check                   check clusters only, don't change any data\n"));
-	printf(_("  -d, --old-datadir=DATADIR     old cluster data directory\n"));
-	printf(_("  -D, --new-datadir=DATADIR     new cluster data directory\n"));
-	printf(_("  -j, --jobs=NUM                number of simultaneous processes or threads to use\n"));
-	printf(_("  -k, --link                    link instead of copying files to new cluster\n"));
-	printf(_("  -o, --old-options=OPTIONS     old cluster options to pass to the server\n"));
-	printf(_("  -O, --new-options=OPTIONS     new cluster options to pass to the server\n"));
-	printf(_("  -p, --old-port=PORT           old cluster port number (default %d)\n"), old_cluster.port);
-	printf(_("  -P, --new-port=PORT           new cluster port number (default %d)\n"), new_cluster.port);
-	printf(_("  -r, --retain                  retain SQL and log files after success\n"));
-	printf(_("  -s, --socketdir=DIR           socket directory to use (default current dir.)\n"));
-	printf(_("  -U, --username=NAME           cluster superuser (default \"%s\")\n"), os_info.user);
-	printf(_("  -v, --verbose                 enable verbose internal logging\n"));
-	printf(_("  -V, --version                 display version information, then exit\n"));
-	printf(_("  --clone                       clone instead of copying files to new cluster\n"));
-	printf(_("  -?, --help                    show this help, then exit\n"));
+	printf(_("  -b, --old-bindir=BINDIR         old cluster executable directory\n"));
+	printf(_("  -B, --new-bindir=BINDIR         new cluster executable directory (default\n"
+			 "                                  same directory as pg_upgrade)\n"));
+	printf(_("  -l, --old-libexecdir=LIBEXECDIR old cluster command directory\n"));
+	printf(_("  -L, --new-libexecdir=LIBEXECDIR new cluster command directory\n"));
+	printf(_("  -c, --check                     check clusters only, don't change any data\n"));
+	printf(_("  -d, --old-datadir=DATADIR       old cluster data directory\n"));
+	printf(_("  -D, --new-datadir=DATADIR       new cluster data directory\n"));
+	printf(_("  -j, --jobs=NUM                  number of simultaneous processes or threads to use\n"));
+	printf(_("  -k, --link                      link instead of copying files to new cluster\n"));
+	printf(_("  -o, --old-options=OPTIONS       old cluster options to pass to the server\n"));
+	printf(_("  -O, --new-options=OPTIONS       new cluster options to pass to the server\n"));
+	printf(_("  -p, --old-port=PORT             old cluster port number (default %d)\n"), old_cluster.port);
+	printf(_("  -P, --new-port=PORT             new cluster port number (default %d)\n"), new_cluster.port);
+	printf(_("  -r, --retain                    retain SQL and log files after success\n"));
+	printf(_("  -s, --socketdir=DIR             socket directory to use (default current dir.)\n"));
+	printf(_("  -U, --username=NAME             cluster superuser (default \"%s\")\n"), os_info.user);
+	printf(_("  -v, --verbose                   enable verbose internal logging\n"));
+	printf(_("  -V, --version                   display version information, then exit\n"));
+	printf(_("  --clone                         clone instead of copying files to new cluster\n"));
+	printf(_("  -?, --help                      show this help, then exit\n"));
 	printf(_("\n"
 			 "Before running pg_upgrade you must:\n"
 			 "  create a new database cluster (using the new version of initdb)\n"
@@ -318,22 +334,28 @@ usage(void)
 			 "  the data directory for the old cluster  (-d DATADIR)\n"
 			 "  the data directory for the new cluster  (-D DATADIR)\n"
 			 "  the \"bin\" directory for the old version (-b BINDIR)\n"
-			 "  the \"bin\" directory for the new version (-B BINDIR)\n"));
+			 "  the \"bin\" directory for the new version (-B BINDIR)\n"
+			 "  the \"libexec\" directory for the old version (-l LIBEXECDIR)\n"
+			 "  the \"libexec\" directory for the new version (-L LIBEXECDIR)\n"));
 	printf(_("\n"
 			 "For example:\n"
-			 "  pg_upgrade -d oldCluster/data -D newCluster/data -b oldCluster/bin -B newCluster/bin\n"
+			 "  pg_upgrade -d oldCluster/data -D newCluster/data -b oldCluster/bin -B newCluster/bin -l oldCluster/libexec -L newCluster/libexec\n"
 			 "or\n"));
 #ifndef WIN32
 	printf(_("  $ export PGDATAOLD=oldCluster/data\n"
 			 "  $ export PGDATANEW=newCluster/data\n"
 			 "  $ export PGBINOLD=oldCluster/bin\n"
 			 "  $ export PGBINNEW=newCluster/bin\n"
+			 "  $ export PGLIBEXECOLD=oldCluster/libexec\n"
+			 "  $ export PGLIBEXECNEW=newCluster/libexec\n"
 			 "  $ pg_upgrade\n"));
 #else
 	printf(_("  C:\\> set PGDATAOLD=oldCluster/data\n"
 			 "  C:\\> set PGDATANEW=newCluster/data\n"
 			 "  C:\\> set PGBINOLD=oldCluster/bin\n"
 			 "  C:\\> set PGBINNEW=newCluster/bin\n"
+			 "  C:\\> set PGLIBEXECOLD=oldCluster/libexec\n"
+			 "  C:\\> set PGLIBEXECNEW=newCluster/libexec\n"
 			 "  C:\\> pg_upgrade\n"));
 #endif
 	printf(_("\nReport bugs to <%s>.\n"), PACKAGE_BUGREPORT);
diff --git a/src/bin/pg_upgrade/pg_upgrade.c b/src/bin/pg_upgrade/pg_upgrade.c
index 70194eb096..8de4710b5b 100644
--- a/src/bin/pg_upgrade/pg_upgrade.c
+++ b/src/bin/pg_upgrade/pg_upgrade.c
@@ -165,14 +165,14 @@ main(int argc, char **argv)
 	 */
 	prep_status("Setting next OID for new cluster");
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/pg_resetwal\" -o %u \"%s\"",
-			  new_cluster.bindir, old_cluster.controldata.chkpnt_nxtoid,
+			  "\"%s\" -o %u \"%s\"",
+			  new_cluster.pg_resetwal_path, old_cluster.controldata.chkpnt_nxtoid,
 			  new_cluster.pgdata);
 	check_ok();
 
 	prep_status("Sync data directory to disk");
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/initdb\" --sync-only \"%s\"", new_cluster.bindir,
+			  "\"%s\" --sync-only \"%s\"", new_cluster.initdb_path,
 			  new_cluster.pgdata);
 	check_ok();
 
@@ -208,11 +208,11 @@ setup(char *argv0, bool *live_check)
 	check_pghost_envvar();
 
 	/*
-	 * In case the user hasn't specified the directory for the new binaries
-	 * with -B, default to using the path of the currently executed pg_upgrade
-	 * binary.
+	 * In case the user hasn't specified the directory for the new commands
+	 * with -L, default to using the path of the currently executed pg_upgrade
+	 * command.
 	 */
-	if (!new_cluster.bindir)
+	if (!new_cluster.libexecdir)
 	{
 		char		exec_path[MAXPGPATH];
 
@@ -221,7 +221,22 @@ setup(char *argv0, bool *live_check)
 		/* Trim off program name and keep just path */
 		*last_dir_separator(exec_path) = '\0';
 		canonicalize_path(exec_path);
-		new_cluster.bindir = pg_strdup(exec_path);
+		new_cluster.libexecdir = pg_strdup(exec_path);
+	}
+
+	/*
+	 * In case the user hasn't specified the directory for the new binaries
+	 * with -B, construct it from the path for libexecdir.
+	 *
+	 * TODO: handle custom bin locations which are not where we expect.
+	 */
+	if (!new_cluster.bindir)
+	{
+		char		tmp[MAXPGPATH * 2];  /* room for relative path change */
+
+		snprintf(tmp, sizeof(tmp), "%s/../bin", new_cluster.libexecdir);
+		canonicalize_path(tmp);
+		new_cluster.bindir = pg_strdup(tmp);
 	}
 
 	verify_directories();
@@ -272,8 +287,8 @@ prepare_new_cluster(void)
 	 */
 	prep_status("Analyzing all rows in the new cluster");
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/vacuumdb\" %s --all --analyze %s",
-			  new_cluster.bindir, cluster_conn_opts(&new_cluster),
+			  "\"%s\" %s --all --analyze %s",
+			  new_cluster.vacuumdb_path, cluster_conn_opts(&new_cluster),
 			  log_opts.verbose ? "--verbose" : "");
 	check_ok();
 
@@ -285,8 +300,8 @@ prepare_new_cluster(void)
 	 */
 	prep_status("Freezing all rows in the new cluster");
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/vacuumdb\" %s --all --freeze %s",
-			  new_cluster.bindir, cluster_conn_opts(&new_cluster),
+			  "\"%s\" %s --all --freeze %s",
+			  new_cluster.vacuumdb_path, cluster_conn_opts(&new_cluster),
 			  log_opts.verbose ? "--verbose" : "");
 	check_ok();
 }
@@ -306,8 +321,8 @@ prepare_new_globals(void)
 	prep_status("Restoring global objects in the new cluster");
 
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/psql\" " EXEC_PSQL_ARGS " %s -f \"%s\"",
-			  new_cluster.bindir, cluster_conn_opts(&new_cluster),
+			  "\"%s\" " EXEC_PSQL_ARGS " %s -f \"%s\"",
+			  new_cluster.psql_path, cluster_conn_opts(&new_cluster),
 			  GLOBALS_DUMP_FILE);
 	check_ok();
 }
@@ -351,9 +366,9 @@ create_new_objects(void)
 				  NULL,
 				  true,
 				  true,
-				  "\"%s/pg_restore\" %s %s --exit-on-error --verbose "
+				  "\"%s\" %s %s --exit-on-error --verbose "
 				  "--dbname postgres \"%s\"",
-				  new_cluster.bindir,
+				  new_cluster.pg_restore_path,
 				  cluster_conn_opts(&new_cluster),
 				  create_opts,
 				  sql_file_name);
@@ -388,9 +403,9 @@ create_new_objects(void)
 
 		parallel_exec_prog(log_file_name,
 						   NULL,
-						   "\"%s/pg_restore\" %s %s --exit-on-error --verbose "
+						   "\"%s\" %s %s --exit-on-error --verbose "
 						   "--dbname template1 \"%s\"",
-						   new_cluster.bindir,
+						   new_cluster.pg_restore_path,
 						   cluster_conn_opts(&new_cluster),
 						   create_opts,
 						   sql_file_name);
@@ -474,17 +489,17 @@ copy_xact_xlog_xid(void)
 	/* set the next transaction id and epoch of the new cluster */
 	prep_status("Setting next transaction ID and epoch for new cluster");
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/pg_resetwal\" -f -x %u \"%s\"",
-			  new_cluster.bindir, old_cluster.controldata.chkpnt_nxtxid,
+			  "\"%s\" -f -x %u \"%s\"",
+			  new_cluster.pg_resetwal_path, old_cluster.controldata.chkpnt_nxtxid,
 			  new_cluster.pgdata);
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/pg_resetwal\" -f -e %u \"%s\"",
-			  new_cluster.bindir, old_cluster.controldata.chkpnt_nxtepoch,
+			  "\"%s\" -f -e %u \"%s\"",
+			  new_cluster.pg_resetwal_path, old_cluster.controldata.chkpnt_nxtepoch,
 			  new_cluster.pgdata);
 	/* must reset commit timestamp limits also */
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/pg_resetwal\" -f -c %u,%u \"%s\"",
-			  new_cluster.bindir,
+			  "\"%s\" -f -c %u,%u \"%s\"",
+			  new_cluster.pg_resetwal_path,
 			  old_cluster.controldata.chkpnt_nxtxid,
 			  old_cluster.controldata.chkpnt_nxtxid,
 			  new_cluster.pgdata);
@@ -509,8 +524,8 @@ copy_xact_xlog_xid(void)
 		 * counters here and the oldest multi present on system.
 		 */
 		exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-				  "\"%s/pg_resetwal\" -O %u -m %u,%u \"%s\"",
-				  new_cluster.bindir,
+				  "\"%s\" -O %u -m %u,%u \"%s\"",
+				  new_cluster.pg_resetwal_path,
 				  old_cluster.controldata.chkpnt_nxtmxoff,
 				  old_cluster.controldata.chkpnt_nxtmulti,
 				  old_cluster.controldata.chkpnt_oldstMulti,
@@ -537,8 +552,8 @@ copy_xact_xlog_xid(void)
 		 * next=MaxMultiXactId, but multixact.c can cope with that just fine.
 		 */
 		exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-				  "\"%s/pg_resetwal\" -m %u,%u \"%s\"",
-				  new_cluster.bindir,
+				  "\"%s\" -m %u,%u \"%s\"",
+				  new_cluster.pg_resetwal_path,
 				  old_cluster.controldata.chkpnt_nxtmulti + 1,
 				  old_cluster.controldata.chkpnt_nxtmulti,
 				  new_cluster.pgdata);
@@ -549,7 +564,7 @@ copy_xact_xlog_xid(void)
 	prep_status("Resetting WAL archives");
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
 	/* use timeline 1 to match controldata and no WAL history file */
-			  "\"%s/pg_resetwal\" -l 00000001%s \"%s\"", new_cluster.bindir,
+			  "\"%s\" -l 00000001%s \"%s\"", new_cluster.pg_resetwal_path,
 			  old_cluster.controldata.nextxlogfile + 8,
 			  new_cluster.pgdata);
 	check_ok();
diff --git a/src/bin/pg_upgrade/pg_upgrade.h b/src/bin/pg_upgrade/pg_upgrade.h
index 8b90cefbe0..272e461b0d 100644
--- a/src/bin/pg_upgrade/pg_upgrade.h
+++ b/src/bin/pg_upgrade/pg_upgrade.h
@@ -260,6 +260,7 @@ typedef struct
 	char	   *pgconfig;		/* pathname for cluster's config file
 								 * directory */
 	char	   *bindir;			/* pathname for cluster's executable directory */
+	char	   *libexecdir;		/* pathname for cluster's command directory */
 	char	   *pgopts;			/* options to pass to the server, like pg_ctl
 								 * -o */
 	char	   *sockdir;		/* directory for Unix Domain socket, if any */
@@ -268,6 +269,18 @@ typedef struct
 	char		major_version_str[64];	/* string PG_VERSION of cluster */
 	uint32		bin_version;	/* version returned from pg_ctl */
 	const char *tablespace_suffix;	/* directory specification */
+
+	/* Validated paths to named executables */
+	char	   *postgres_path;
+	char	   *pg_controldata_path;
+	char	   *pg_ctl_path;
+	char	   *pg_resetwal_path;
+	char	   *initdb_path;
+	char	   *pg_dump_path;
+	char	   *pg_dumpall_path;
+	char	   *pg_restore_path;
+	char	   *psql_path;
+	char	   *vacuumdb_path;
 } ClusterInfo;
 
 
diff --git a/src/bin/pg_upgrade/server.c b/src/bin/pg_upgrade/server.c
index 7d17280ecb..fbe114c8bd 100644
--- a/src/bin/pg_upgrade/server.c
+++ b/src/bin/pg_upgrade/server.c
@@ -241,8 +241,8 @@ start_postmaster(ClusterInfo *cluster, bool report_and_exit_on_error)
 	 * win on ext4.
 	 */
 	snprintf(cmd, sizeof(cmd),
-			 "\"%s/pg_ctl\" -w -l \"%s\" -D \"%s\" -o \"-p %d%s%s %s%s\" start",
-			 cluster->bindir, SERVER_LOG_FILE, cluster->pgconfig, cluster->port,
+			 "\"%s\" -w -l \"%s\" -D \"%s\" -o \"-p %d%s%s %s%s\" start",
+			 cluster->pg_ctl_path, SERVER_LOG_FILE, cluster->pgconfig, cluster->port,
 			 (cluster->controldata.cat_ver >=
 			  BINARY_UPGRADE_SERVER_FLAG_CAT_VER) ? " -b" :
 			 " -c autovacuum=off -c autovacuum_freeze_max_age=2000000000",
@@ -336,8 +336,8 @@ stop_postmaster(bool in_atexit)
 		return;					/* no cluster running */
 
 	exec_prog(SERVER_STOP_LOG_FILE, NULL, !in_atexit, !in_atexit,
-			  "\"%s/pg_ctl\" -w -D \"%s\" -o \"%s\" %s stop",
-			  cluster->bindir, cluster->pgconfig,
+			  "\"%s\" -w -D \"%s\" -o \"%s\" %s stop",
+			  cluster->pg_ctl_path, cluster->pgconfig,
 			  cluster->pgopts ? cluster->pgopts : "",
 			  in_atexit ? "-m fast" : "-m smart");
 
diff --git a/src/bin/pg_upgrade/test.sh b/src/bin/pg_upgrade/test.sh
index 10a28d8133..ef3f3b32ec 100644
--- a/src/bin/pg_upgrade/test.sh
+++ b/src/bin/pg_upgrade/test.sh
@@ -76,6 +76,7 @@ rm -rf "$temp_root"
 mkdir "$temp_root"
 
 : ${oldbindir=$bindir}
+: ${oldlibexecdir=$libexecdir}
 
 : ${oldsrc=../../..}
 oldsrc=`cd "$oldsrc" && pwd`
@@ -86,13 +87,13 @@ newsrc=`cd ../../.. && pwd`
 # below would try to use psql from the proper installation directory
 # of the target version, which might be outdated or not exist. But
 # don't override anything else that's already in EXTRA_REGRESS_OPTS.
-EXTRA_REGRESS_OPTS="$EXTRA_REGRESS_OPTS --bindir='$oldbindir'"
+EXTRA_REGRESS_OPTS="$EXTRA_REGRESS_OPTS --bindir='$oldbindir' --libexecdir='$oldlibexecdir'"
 export EXTRA_REGRESS_OPTS
 
 # While in normal cases this will already be set up, adding bindir to
 # path allows test.sh to be invoked with different versions as
 # described in ./TESTING
-PATH=$bindir:$PATH
+PATH=$bindir:$libexecdir:$PATH
 export PATH
 
 BASE_PGDATA="$temp_root/data"
@@ -150,8 +151,8 @@ done
 EXTRA_REGRESS_OPTS="$EXTRA_REGRESS_OPTS --port=$PGPORT"
 export EXTRA_REGRESS_OPTS
 
-standard_initdb "$oldbindir"/initdb
-"$oldbindir"/pg_ctl start -l "$logdir/postmaster1.log" -o "$POSTMASTER_OPTS" -w
+standard_initdb "$oldlibexecdir"/initdb
+"$oldlibexecdir"/pg_ctl start -l "$logdir/postmaster1.log" -o "$POSTMASTER_OPTS" -w
 
 # Create databases with names covering the ASCII bytes other than NUL, BEL,
 # LF, or CR.  BEL would ring the terminal bell in the course of this test, and
@@ -204,7 +205,7 @@ if "$MAKE" -C "$oldsrc" installcheck-parallel; then
 else
 	make_installcheck_status=$?
 fi
-"$oldbindir"/pg_ctl -m fast stop
+"$oldlibexecdir"/pg_ctl -m fast stop
 if [ -n "$createdb_status" ]; then
 	exit 1
 fi
@@ -223,7 +224,7 @@ PGDATA="$BASE_PGDATA"
 
 standard_initdb 'initdb'
 
-pg_upgrade $PG_UPGRADE_OPTS -d "${PGDATA}.old" -D "$PGDATA" -b "$oldbindir" -p "$PGPORT" -P "$PGPORT"
+pg_upgrade $PG_UPGRADE_OPTS -d "${PGDATA}.old" -D "$PGDATA" -b "$oldbindir" -l "$oldlibexecdir" -p "$PGPORT" -P "$PGPORT"
 
 # make sure all directories and files have group permissions, on Unix hosts
 # Windows hosts don't support Unix-y permissions.
diff --git a/src/bin/pg_verifybackup/Makefile b/src/bin/pg_verifybackup/Makefile
index c07643b129..710a6a9972 100644
--- a/src/bin/pg_verifybackup/Makefile
+++ b/src/bin/pg_verifybackup/Makefile
@@ -21,13 +21,13 @@ pg_verifybackup: $(OBJS) | submake-libpq submake-libpgport submake-libpgfeutils
 	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_verifybackup$(X) '$(DESTDIR)$(bindir)/pg_verifybackup$(X)'
+	$(INSTALL_PROGRAM) pg_verifybackup$(X) '$(DESTDIR)$(libexecdir)/pg_verifybackup$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pg_verifybackup$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pg_verifybackup$(X)'
 
 clean distclean maintainer-clean:
 	rm -f pg_verifybackup$(X) $(OBJS)
diff --git a/src/bin/pg_verifybackup/pg_verifybackup.c b/src/bin/pg_verifybackup/pg_verifybackup.c
index 70b6ffdec0..6979006671 100644
--- a/src/bin/pg_verifybackup/pg_verifybackup.c
+++ b/src/bin/pg_verifybackup/pg_verifybackup.c
@@ -285,9 +285,9 @@ main(int argc, char **argv)
 		int			ret;
 
 		pg_waldump_path = pg_malloc(MAXPGPATH);
-		ret = find_other_exec(argv[0], "pg_waldump",
-							  "pg_waldump (PostgreSQL) " PG_VERSION "\n",
-							  pg_waldump_path);
+		ret = find_other_cmd(argv[0], "pg_waldump",
+							 "pg_waldump (PostgreSQL) " PG_VERSION "\n",
+							 pg_waldump_path);
 		if (ret < 0)
 		{
 			char		full_path[MAXPGPATH];
diff --git a/src/bin/pg_verifybackup/t/008_redirect.pl b/src/bin/pg_verifybackup/t/008_redirect.pl
new file mode 100644
index 0000000000..719febb3b3
--- /dev/null
+++ b/src/bin/pg_verifybackup/t/008_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'verifybackup'],
+	qr/fatal: no backup directory specified/,
+	'pg pg_verifybackup fails');
+
+command_ok(
+	['pg', 'verifybackup', '--version'],
+	'pg pg_verifybackup version ok');
+
+command_ok(
+	['pg', 'verifybackup', '--help'],
+	'pg pg_verifybackup help ok');
diff --git a/src/bin/pg_waldump/Makefile b/src/bin/pg_waldump/Makefile
index 9f333d0c8a..a8680f115d 100644
--- a/src/bin/pg_waldump/Makefile
+++ b/src/bin/pg_waldump/Makefile
@@ -33,13 +33,13 @@ $(RMGRDESCSOURCES): % : $(top_srcdir)/src/backend/access/rmgrdesc/%
 	rm -f $@ && $(LN_S) $< .
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_waldump$(X) '$(DESTDIR)$(bindir)/pg_waldump$(X)'
+	$(INSTALL_PROGRAM) pg_waldump$(X) '$(DESTDIR)$(libexecdir)/pg_waldump$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pg_waldump$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pg_waldump$(X)'
 
 clean distclean maintainer-clean:
 	rm -f pg_waldump$(X) $(OBJS) $(RMGRDESCSOURCES) xlogreader.c
diff --git a/src/bin/pg_waldump/t/002_redirect.pl b/src/bin/pg_waldump/t/002_redirect.pl
new file mode 100644
index 0000000000..84453df680
--- /dev/null
+++ b/src/bin/pg_waldump/t/002_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'waldump'],
+	qr/error: no arguments specified/,
+	'pg pg_waldump fails');
+
+command_ok(
+	['pg', 'waldump', '--version'],
+	'pg pg_waldump version ok');
+
+command_ok(
+	['pg', 'waldump', '--help'],
+	'pg pg_waldump help ok');
diff --git a/src/bin/pgbench/Makefile b/src/bin/pgbench/Makefile
index f402fe7b91..4b430cb53d 100644
--- a/src/bin/pgbench/Makefile
+++ b/src/bin/pgbench/Makefile
@@ -32,13 +32,13 @@ exprparse.o: exprscan.c
 distprep: exprparse.c exprscan.c
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pgbench$(X) '$(DESTDIR)$(bindir)/pgbench$(X)'
+	$(INSTALL_PROGRAM) pgbench$(X) '$(DESTDIR)$(libexecdir)/pgbench$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pgbench$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pgbench$(X)'
 
 clean distclean:
 	rm -f pgbench$(X) $(OBJS)
diff --git a/src/bin/pgbench/t/003_redirect.pl b/src/bin/pgbench/t/003_redirect.pl
new file mode 100644
index 0000000000..bbc0a11e5b
--- /dev/null
+++ b/src/bin/pgbench/t/003_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'bench'],
+	qr/error: connection to database .* failed/,
+	'pg bench fails');
+
+command_ok(
+	['pg', 'bench', '--version'],
+	'pg bench version ok');
+
+command_ok(
+	['pg', 'bench', '--help'],
+	'pg bench help ok');
diff --git a/src/bin/psql/startup.c b/src/bin/psql/startup.c
index 3302bd4dd3..b50f3b6e46 100644
--- a/src/bin/psql/startup.c
+++ b/src/bin/psql/startup.c
@@ -755,6 +755,7 @@ process_psqlrc(char *argv0)
 	char		home[MAXPGPATH];
 	char		rc_file[MAXPGPATH];
 	char		my_exec_path[MAXPGPATH];
+	char		my_rootdir[MAXPGPATH];
 	char		etc_path[MAXPGPATH];
 	char	   *envrc = getenv("PSQLRC");
 
@@ -764,7 +765,13 @@ process_psqlrc(char *argv0)
 		exit(EXIT_FAILURE);
 	}
 
-	get_etc_path(my_exec_path, etc_path);
+	if (find_my_rootdir(argv0, my_rootdir) < 0)
+	{
+		pg_log_fatal("could not find own program root directory");
+		exit(EXIT_FAILURE);
+	}
+
+	get_etc_path(my_rootdir, etc_path);
 
 	snprintf(rc_file, MAXPGPATH, "%s/%s", etc_path, SYSPSQLRC);
 	process_psqlrc_file(rc_file);
diff --git a/src/bin/scripts/Makefile b/src/bin/scripts/Makefile
index 42bfe475b2..047767e602 100644
--- a/src/bin/scripts/Makefile
+++ b/src/bin/scripts/Makefile
@@ -33,20 +33,20 @@ reindexdb: reindexdb.o common.o scripts_parallel.o $(WIN32RES) | submake-libpq s
 pg_isready: pg_isready.o common.o $(WIN32RES) | submake-libpq submake-libpgport submake-libpgfeutils
 
 install: all installdirs
-	$(INSTALL_PROGRAM) createdb$(X)   '$(DESTDIR)$(bindir)'/createdb$(X)
-	$(INSTALL_PROGRAM) dropdb$(X)     '$(DESTDIR)$(bindir)'/dropdb$(X)
-	$(INSTALL_PROGRAM) createuser$(X) '$(DESTDIR)$(bindir)'/createuser$(X)
-	$(INSTALL_PROGRAM) dropuser$(X)   '$(DESTDIR)$(bindir)'/dropuser$(X)
-	$(INSTALL_PROGRAM) clusterdb$(X)  '$(DESTDIR)$(bindir)'/clusterdb$(X)
-	$(INSTALL_PROGRAM) vacuumdb$(X)   '$(DESTDIR)$(bindir)'/vacuumdb$(X)
-	$(INSTALL_PROGRAM) reindexdb$(X)  '$(DESTDIR)$(bindir)'/reindexdb$(X)
-	$(INSTALL_PROGRAM) pg_isready$(X) '$(DESTDIR)$(bindir)'/pg_isready$(X)
+	$(INSTALL_PROGRAM) createdb$(X)   '$(DESTDIR)$(libexecdir)'/createdb$(X)
+	$(INSTALL_PROGRAM) dropdb$(X)     '$(DESTDIR)$(libexecdir)'/dropdb$(X)
+	$(INSTALL_PROGRAM) createuser$(X) '$(DESTDIR)$(libexecdir)'/createuser$(X)
+	$(INSTALL_PROGRAM) dropuser$(X)   '$(DESTDIR)$(libexecdir)'/dropuser$(X)
+	$(INSTALL_PROGRAM) clusterdb$(X)  '$(DESTDIR)$(libexecdir)'/clusterdb$(X)
+	$(INSTALL_PROGRAM) vacuumdb$(X)   '$(DESTDIR)$(libexecdir)'/vacuumdb$(X)
+	$(INSTALL_PROGRAM) reindexdb$(X)  '$(DESTDIR)$(libexecdir)'/reindexdb$(X)
+	$(INSTALL_PROGRAM) pg_isready$(X) '$(DESTDIR)$(libexecdir)'/pg_isready$(X)
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f $(addprefix '$(DESTDIR)$(bindir)'/, $(addsuffix $(X), $(PROGRAMS)))
+	rm -f $(addprefix '$(DESTDIR)$(libexecdir)'/, $(addsuffix $(X), $(PROGRAMS)))
 
 clean distclean maintainer-clean:
 	rm -f $(addsuffix $(X), $(PROGRAMS)) $(addsuffix .o, $(PROGRAMS))
diff --git a/src/common/.gitignore b/src/common/.gitignore
index ffa3284fbf..20ea8ef820 100644
--- a/src/common/.gitignore
+++ b/src/common/.gitignore
@@ -1 +1,2 @@
 /kwlist_d.h
+/pg_exec_relpath.h
diff --git a/src/common/Makefile b/src/common/Makefile
index d0be882cca..5279fe9056 100644
--- a/src/common/Makefile
+++ b/src/common/Makefile
@@ -99,6 +99,10 @@ OBJS_FRONTEND = \
 OBJS_SHLIB = $(OBJS_FRONTEND:%.o=%_shlib.o)
 OBJS_SRV = $(OBJS_COMMON:%.o=%_srv.o)
 
+# Generate bin and libexec relative paths
+pg_exec_relpath.h: mk_exec_relpath.pl
+	$(PERL) $(srcdir)/$^ '$(DESTDIR)$(bindir)' '$(DESTDIR)$(libexecdir)' > $@
+
 # where to find gen_keywordlist.pl and subsidiary files
 TOOLSDIR = $(top_srcdir)/src/tools
 GEN_KEYWORDLIST = $(PERL) -I $(TOOLSDIR) $(TOOLSDIR)/gen_keywordlist.pl
@@ -108,6 +112,8 @@ all: libpgcommon.a libpgcommon_shlib.a libpgcommon_srv.a
 
 distprep: kwlist_d.h
 
+exec.o: pg_exec_relpath.h
+
 # libpgcommon is needed by some contrib
 install: all installdirs
 	$(INSTALL_STLIB) libpgcommon.a '$(DESTDIR)$(libdir)/libpgcommon.a'
@@ -175,7 +181,7 @@ $(RYU_OBJS): CFLAGS += $(PERMIT_DECLARATION_AFTER_STATEMENT)
 
 # kwlist_d.h is in the distribution tarball, so it is not cleaned here.
 clean distclean:
-	rm -f libpgcommon.a libpgcommon_shlib.a libpgcommon_srv.a
+	rm -f libpgcommon.a libpgcommon_shlib.a libpgcommon_srv.a pg_exec_relpath.h
 	rm -f $(OBJS_FRONTEND) $(OBJS_SHLIB) $(OBJS_SRV)
 
 maintainer-clean: distclean
diff --git a/src/common/config_info.c b/src/common/config_info.c
index 8a5dc64ec3..44089aeff5 100644
--- a/src/common/config_info.c
+++ b/src/common/config_info.c
@@ -30,18 +30,22 @@
  * for pfreeing the result.
  */
 ConfigData *
-get_configdata(const char *my_exec_path, size_t *configdata_len)
+get_configdata(const char *my_exec_path, const char *my_rootdir,
+			   size_t *configdata_len)
 {
 	ConfigData *configdata;
 	char		path[MAXPGPATH];
 	char	   *lastsep;
 	int			i = 0;
 
+	Assert (my_rootdir != NULL);
+	Assert (my_rootdir[0] != '\0');
+
 	/* Adjust this to match the number of items filled below */
-	*configdata_len = 23;
+	*configdata_len = 24;
 	configdata = (ConfigData *) palloc(*configdata_len * sizeof(ConfigData));
 
-	configdata[i].name = pstrdup("BINDIR");
+	configdata[i].name = pstrdup("LIBEXECDIR");
 	strlcpy(path, my_exec_path, sizeof(path));
 	lastsep = strrchr(path, '/');
 	if (lastsep)
@@ -51,13 +55,13 @@ get_configdata(const char *my_exec_path, size_t *configdata_len)
 	i++;
 
 	configdata[i].name = pstrdup("DOCDIR");
-	get_doc_path(my_exec_path, path);
+	get_doc_path(my_rootdir, path);
 	cleanup_path(path);
 	configdata[i].setting = pstrdup(path);
 	i++;
 
 	configdata[i].name = pstrdup("HTMLDIR");
-	get_html_path(my_exec_path, path);
+	get_html_path(my_rootdir, path);
 	cleanup_path(path);
 	configdata[i].setting = pstrdup(path);
 	i++;
@@ -75,13 +79,19 @@ get_configdata(const char *my_exec_path, size_t *configdata_len)
 	i++;
 
 	configdata[i].name = pstrdup("INCLUDEDIR-SERVER");
-	get_includeserver_path(my_exec_path, path);
+	get_includeserver_path(my_rootdir, path);
 	cleanup_path(path);
 	configdata[i].setting = pstrdup(path);
 	i++;
 
 	configdata[i].name = pstrdup("LIBDIR");
-	get_lib_path(my_exec_path, path);
+	get_lib_path(my_rootdir, path);
+	cleanup_path(path);
+	configdata[i].setting = pstrdup(path);
+	i++;
+
+	configdata[i].name = pstrdup("BINDIR");
+	get_bin_path(my_rootdir, path);
 	cleanup_path(path);
 	configdata[i].setting = pstrdup(path);
 	i++;
@@ -99,7 +109,7 @@ get_configdata(const char *my_exec_path, size_t *configdata_len)
 	i++;
 
 	configdata[i].name = pstrdup("MANDIR");
-	get_man_path(my_exec_path, path);
+	get_man_path(my_rootdir, path);
 	cleanup_path(path);
 	configdata[i].setting = pstrdup(path);
 	i++;
@@ -111,7 +121,7 @@ get_configdata(const char *my_exec_path, size_t *configdata_len)
 	i++;
 
 	configdata[i].name = pstrdup("SYSCONFDIR");
-	get_etc_path(my_exec_path, path);
+	get_etc_path(my_rootdir, path);
 	cleanup_path(path);
 	configdata[i].setting = pstrdup(path);
 	i++;
